/* 
 * File:   SayAndHearModel.cpp
 * Author: robocup
 * 
 * Created on 7/1/2011
 */

#include "SayAndHearModel.h"
#include<stdlib.h>

#include <cmath>
#include <string>
#include <sstream>
#include <vector>
namespace core {
    using namespace std;
    using namespace boost;

    void SayAndHearModel::update() {
        calcCanSay();
        makeMsg();

        const vector<shared_ptr<perception::Hear> >& hear = WM.lastPerception().hear();
        if (hear.empty()) {
            mIsHeard = false;
            return;
        }
        mIsHeard = false;

        FOR_EACH(iter, hear) {
            mHearString = ((*iter)->message());
            // ;
            mIsHeard = resolveMsg();
            break;
        }

    }

    void SayAndHearModel::calcCanSay() {
        int time = std::floor(WM.getSimTime()*100);
        int myUnum = WM.getMyUnum();
        const int teamNum = 11;
        int mod = time % 180;
        int type = (mod / 4) % teamNum;

        if (myUnum - 1 == type) {
            mCanSay = true;
        } else {
            mCanSay = false;
        }
    }
    
  
    void SayAndHearModel::calcOurGoodPos(char* send,std::vector<int> pos)	//add by ghd
    {
	unsigned int tempInt;
	std::vector<int>::iterator posIter =pos.begin();
	tempInt =(*posIter) *10 +(*(posIter+1));
	send[0] =char(tempInt);
	posIter+=2;
	tempInt =(*posIter) *10 +(*(posIter+1));
	send[1] =char(tempInt);
	posIter+=2;
	tempInt =(*posIter) *10 +(*(posIter+1));
	send[2] =char(tempInt);
    }

    unsigned int SayAndHearModel::resolveOurGoodPos(char* recive)	//ghd
    {
	unsigned int tempInt;
	unsigned int x[3];
	unsigned int myID =WM.getMyUnum();
	for(int i =0;i<3;i++)
	{
	    x[i] =int(recive[i]);
	}
	
	//type
	tempInt =x[2]%10;
	mHearCastType =tempInt -2;
	  
	//tempInt: 2 ~ 11	5 player
	//byte 1
	tempInt =x[0]%10;
	if(tempInt <2)tempInt +=10;
	if(tempInt ==myID)return 1;
	else
	{
	  x[0] -=tempInt;
	  x[0] /=10;
	  if(x[0] ==myID)return 0;
	}
	//byte 2
	tempInt =x[1]%10;
	if(tempInt <2)tempInt +=10;
	if(tempInt ==myID)return 3;
	else
	{
	  x[1] -=tempInt;
	  x[1] /=10;
	  if(x[1] ==myID)return 2;
	}
	//byte 3
	tempInt =x[2]%10;
	x[2] -=tempInt;
	x[2] /=10;
	if(x[2] ==myID)return 4;
	
	return dynamic_no_me;
	  
    }
    
    void SayAndHearModel::calcOurGoodPosMinor(char* send, std::vector<int> pos)
    {
	unsigned int tempInt;
	std::vector<int>::iterator posIter =pos.begin();
	//first sendID
	tempInt = *posIter;
	send[0] = char(tempInt);
	posIter++;
	//second sendID
	tempInt = *posIter;
	send[1] = char(tempInt);
	posIter++;
	//third sendID
	tempInt = *posIter;
	send[2] = char(tempInt);
	posIter++;
	//send castType
    }
	
    unsigned int SayAndHearModel::resolveOurGoodPosMinor(char* recieve)
    {
	unsigned int tempInt;
	unsigned int receivePos[4];
	unsigned int myID =WM.getMyUnum();
	
	for(int i=0; i<4; i++){
	    receivePos[i] = (int)(recieve[i]);
	}

	tempInt = receivePos[3];
	mHearCastType = tempInt-2;
	
	tempInt = receivePos[0];
	if(tempInt == myID)
	  return 0;
	
	tempInt = receivePos[1];
	if(tempInt == myID)
	  return 1;
	
	tempInt = receivePos[2];
	if(tempInt == myID)
	  return 2;
	

    }
       
    void SayAndHearModel::calcTimeToBall(){
	const float speed = 0.4f;
        mTimeToBall = 0.0f;
        float dist;
	seumath::Vector2f ballRelPos = WM.getBallRelPos2D();
	dist = ballRelPos .length();
	mTimeToBall += dist / speed;
//         if (dist.length()<0.5f){	//ghd
// 	  mTimeToBall=0.0f;
// 	  return;
// 	  
// 	}

        if (WM.isFall()) {
            mTimeToBall += 3.5f; //由2.7改到0.9,没有什么依据
        }
        //下面原是根据角度增加到球时间,现在不用
	float balldir = (seumath::Vector2f(serversetting::half_field_length,0) - WM.getBallGlobalPos2D()).angle();  // modify by ghd
	//float oppdir =(Vector2f(half_field_length,0) - mHearGlobalPos).angle();
	//cout<< abs(normalizeAngle(balldir - mHearBodyDirection)) / 180.0f * 3.0f <<endl;
	if(WM.getBallGlobalPos2D().x() >0.0f)
	    mTimeToBall += abs(seumath::normalizeAngle(balldir - WM.getMyBodyDirection())) / 180.0f * 5.0f;
	else mTimeToBall += abs(seumath::normalizeAngle(balldir - WM.getMyBodyDirection())) / 180.0f * 3.0f;


//下面部分是增加在球前方的球员的时间惩罚
	if (WM.getBallGlobalPos2D().x() < WM.getMyGlobalPos2D().x()) {
	    mTimeToBall += 4.0f * ((WM.getMyGlobalPos2D().x() - WM.getBallGlobalPos2D().x()) / speed);
	}           
	else if (WM.getBallGlobalPos2D().x() < WM.getMyGlobalPos2D().x()) {
	    mTimeToBall += 4.0f * ((WM.getMyGlobalPos2D().x()-WM.getBallGlobalPos2D().x()) / speed);
	}
}
    
    void SayAndHearModel::makeMsg() {
        mSayString = "";
        std::stringstream ss;
        int tempInt = 0;
        char tempH;
        char tempL;
        //playerID
        // tempInt = formatInt(WM.getMyUnum());
        //  DecToEightyFifth(tempInt, tempH, tempL);
        ss << (char) (WM.getMyUnum() + '*');
	
	//modify by ghd
	calcTimeToBall();
	
	tempInt = std::floor(mTimeToBall * 10);
        tempInt += (mBase * mBase / 2);
	DecToEightyFifth(tempInt,tempH,tempL);
	ss<<tempH<<tempL;
        //player pos x,y
       /* tempInt = formatFloat(WM.getMyGlobalPos().x());
        DecToEightyFifth(tempInt, tempH, tempL);
        ss << tempH << tempL;

        tempInt = formatFloat(WM.getMyGlobalPos().y());
        DecToEightyFifth(tempInt, tempH, tempL);
        ss << tempH << tempL;
        //player bodydir
        tempInt = formatFloat(WM.getMyBodyDirection() / 10.0f);
        DecToEightyFifth(tempInt, tempH, tempL);  
        ss << tempH << tempL;
        //player is fallen
        if (WM.isFall()) {
            ss << '1';
        } else {
            ss << '0';
        }*/
        //now time
        tempInt = formatFloat(WM.getBallGlobalPos().x());
        DecToEightyFifth(tempInt, tempH, tempL);
        ss << tempH << tempL;
        tempInt = formatFloat(WM.getBallGlobalPos().y());
        DecToEightyFifth(tempInt, tempH, tempL);
        ss << tempH << tempL;

        float time = WM.getSimTime() - std::floor(WM.getSimTime() / 10)*10;
        tempInt = formatFloat(time);
        DecToEightyFifth(tempInt, tempH, tempL);
        ss << tempH << tempL;
	
	/*this->statusToTurnOnDynamicCast = WM.getTheStatusToTurnOnDynamicCast();
	*/
 	if(PM.mIsDriving)
 	{
 	    unsigned int castType =WM.getOurState();		//add by ghd ,choose state
	    std::vector<int> mGoodPosID(PM.getOurCast());
 	    mGoodPosID.push_back(castType+2);
 	    
//  	    char send[4];			//add by ghd ,to send pos
	    char send[3];
	    calcOurGoodPos(send,mGoodPosID);
 	    //calcOurGoodPosMinor(send,mGoodPosID);
 	    //cout<<int(send[0])<<'\t'<<int(send[1])<<'\t'<<int(send[2])<<endl;
//  	    ss << send[0] << send[1] << send[2] <<send[3];
	    ss<<send[0]<<send[1]<<send[2];
 	}
        
        //the end
        ss<< '~';
        mSayString = ss.str();
    }
    
    bool SayAndHearModel::resolveMsg() {
        const int offset = 2;
        if (mHearString.size() < offset + 6) {
            return false;
        }
        int tempInt = 0;
        char tempH;
        char tempL;
        tempL = mHearString[offset + 0];

        mHearPlayerID = tempL - '*';
        
        tempH =mHearString[offset +1];
	tempL =mHearString[offset +2];
	EightyFifthToDec(tempH, tempL, tempInt);
        mHearPlayerDist = tempInt - (mBase * mBase / 2);
        mHearPlayerDist /= 10.0f;
	
// 	cout<<mHearPlayerID<<'\t'<<mHearPlayerDist<<endl;
/*
        tempH = mHearString[offset + 1];
        tempL = mHearString[offset + 2];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearPlayerPos.x() = resolveFloat(tempInt);

        tempH = mHearString[offset + 3];
        tempL = mHearString[offset + 4];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearPlayerPos.y() = resolveFloat(tempInt);

        tempH = mHearString[offset + 5];
        tempL = mHearString[offset + 6];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearPlayerBodyDirection = resolveFloat(tempInt)*10.0f;
        ;
	
        tempH = mHearString[offset + 7];
        if (tempH == '1') {
            mHearIsPlayerFallen = true;
        } else {
            mHearIsPlayerFallen = false;
        }*/
        tempH = mHearString[offset + 3];
        tempL = mHearString[offset + 4];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearBallPos.x() = resolveFloat(tempInt);

        tempH = mHearString[offset + 5];
        tempL = mHearString[offset + 6];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearBallPos.y() = resolveFloat(tempInt);

        tempH = mHearString[offset + 7];
        tempL = mHearString[offset + 8];
        EightyFifthToDec(tempH, tempL, tempInt);
        mHearSendTime = resolveFloat(tempInt);
	
	if(mHearPlayerID !=WM.getMyUnum() && mHearString[offset +9]!='~' && WM.getMyUnum() >=1)
	{   
	    char recive[3];
// 	    char recive[3];
	    recive[0] = mHearString[offset +9];
	    recive[1] = mHearString[offset +10];
	    recive[2] = mHearString[offset +11];
	    mHearGoodPosID =resolveOurGoodPos(recive);
	    if(mHearGoodPosID != dynamic_no_me)
	    mJoin =true;
	      else
	    mJoin =false;
	    //cout<<mHearCastType<<endl;
	   // cout<<mHearGoodPosID<<endl;
	}
	
	
	
        return true;

    }

       void SayAndHearModel::printsay() {

//            cout << "mSayString" << mSayString << endl;
//            cout << "mSayPlayerID" << WM.getMyUnum() << endl;
//            cout << "mSayPlayerPos" << WM.getMyGlobalPos2D() << endl;
//            cout << "mSayPlayerBodyDirection" << WM.getMyBodyDirection() << endl;
//            cout << "mSayIsPlayerFallen" << WM.isFall() << endl;
//            cout << "mSayBallPos" << WM.getBallGlobalPos() << endl;
//            cout << "mSaySendTime" << WM.getSimTime() << " " << WM.getSimTime() - std::floor(WM.getSimTime() / 10)*10 << endl;
        }


}
